import FTLNomadItemSheet from "./base-item-sheet.mjs"

export default class FTLNomadArmorSheet extends FTLNomadItemSheet {
  /** @override */
  static DEFAULT_OPTIONS = {
    classes: ["armor"],
    position: {
      width: 400,
    },
    window: {
      contentClasses: ["armor-content"],
    },
  }

  /** @override */
  static PARTS = {
    main: {
      template: "systems/fvtt-ftl-nomad/templates/armor.hbs",
    },
  }

  /** @override */
  async _prepareContext() {
    const context = await super._prepareContext()
    context.enrichedDescription = await TextEditor.enrichHTML(this.document.system.description, { async: true })

    return context
  }
}
